config/routes.rb
Rails.application.routes.draw do
  root 'messages#home'
  
  resources :users
  resources :messages

  post   '/',                    to: 'messages#save'

  get    '/messages/:id/delete', to: 'messages#destroy'
  
  get    '/signup',              to: 'users#new'
  get    '/login',               to: 'sessions#new'
  post   '/login',               to: 'sessions#create'
  get    '/logout',              to: 'sessions#destroy'
  delete '/logout',              to: 'sessions#destroy'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/message.rb
class Message < ApplicationRecord
  belongs_to :user

  validates :title, presence: true
  validates :body, presence: true
end

app/models/settings.rb
class Settings
  include ActiveModel::Model
  attr_accessor :xssStore, :xssRender, :accessControl

  def initialize(attributes={})
    super
    @xssStore ||= true
    @xssRender ||= true
    @accessControl ||= true
  end
end

app/models/user.rb
class User < ApplicationRecord
  has_many :messages
  has_secure_password

  validates :name, presence: true
  validates :password, presence: true, length: { minimum: 6 }
end

app/controllers/application_controller.rb
include SessionsHelper

class ApplicationController < ActionController::Base
  before_action :load_settings

  private
  def logged_in_user
      unless logged_in?
        store_location
        flash[:danger] = "Please log in."
        redirect_to login_url
      end
  end

  def load_settings
    @settings = session[:settings]
    @settings ||= { 'xssStore' => true, 'xssRender' => true, 'accessControl' => true }
  end
  
  def check_if_true(item)
    ActiveModel::Type::Boolean.new.cast(item)
  end
end

app/controllers/messages_controller.rb
class MessagesController < ApplicationController
  before_action :logged_in_user, only: [:new, :create, :edit, :update, :destroy]
  before_action :authorize, only: [:edit, :update, :destroy]

  def home
  end

  def save
    @settings['xssStore'] = settings_params[:xssStore]
    @settings['xssRender'] = settings_params[:xssRender]
    @settings['accessControl'] = settings_params[:accessControl]
    
    session[:settings] = @settings

    flash[:success] = "Saved!"
    redirect_to root_path
  end

  def new
    @message  = current_user.messages.new
  end

  def index
    @messages = Message.all
  end

  def create
    attributes = message_params.clone
    if check_if_true(@settings['xssStore'])
      sanitizer = Rails::Html::FullSanitizer.new
      attributes[:title] = sanitizer.sanitize(attributes[:title])
      attributes[:body] = sanitizer.sanitize(attributes[:body])
    end

    @message = current_user.messages.build(attributes)
    if @message.save
      flash[:success] = "Message has been created!"
      redirect_to @message
    else
      render 'new'
    end
  end

  def edit
    @message = Message.find(params[:id])
  end

  def update
    attributes = message_params.clone
    if check_if_true(@settings['xssStore'])
      sanitizer = Rails::Html::FullSanitizer.new
      attributes[:title] = sanitizer.sanitize(attributes[:title])
      attributes[:body] = sanitizer.sanitize(attributes[:body])
    end
    
    @message = Message.find(params[:id])
    if @message.update(attributes)
      flash[:success] = "Message updated"
      redirect_to @message
    else
      render 'edit'
    end
  end

  def destroy
    @message = Message.find(params[:id])

    if @message
      @message.destroy
      flash[:success] = "Message has been deleted"
    else
      flash[:danger] = "Error"
    end
    redirect_to messages_path
  end

  def show
    @message = Message.find(params[:id])
  end

  private

  def settings_params
    params.require(:settings).permit(:xssStore, :xssRender, :accessControl)
  end

  def message_params
    params.require(:message).permit(:title, :body)
  end

  def authorize
    load_settings
    message = Message.find(params[:id])

    if check_if_true(@settings['accessControl'])
      unless message.user == current_user || current_user.role == 'admin'
        flash[:danger] = "You don't have permission!"
        redirect_to messages_path
      end
    end
  end
end

app/controllers/sessions_controller.rb
class SessionsController < ApplicationController
  def new
  end

  def create
    user = User.find_by(name: params[:session][:name])
    if user && user.authenticate(params[:session][:password])
      log_in user
      redirect_back_or user
    else
      flash[:danger] = 'Invalid email/password combination'
      render 'new'
    end
  end

  def destroy
    log_out
    redirect_to root_url
  end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  before_action :logged_in_user, only: [:show]

  def show
    @user = User.find(params[:id])
  end

  def new
    @user = User.new
  end

  def create
    @user = User.new(user_params)
    @user.role = 'user'
    if @user.save
      log_in @user
      flash[:success] = "Welcome to the app!"
      redirect_to @user
    else
      render 'new'
    end
  end

  private

  def user_params
    params.require(:user).permit(:name, :email, :password, :password_confirmation)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
  def check_if_true(item)
    ActiveModel::Type::Boolean.new.cast(item)
  end

  def check_xss_render(item)
    if check_if_true(@settings['xssRender'])
      return item
    else
      return item.html_safe
    end
  end
end

app/helpers/messages_helper.rb
module MessagesHelper
  def can_edit(message, user)
    message.user == user
  end

  def can_delete(message, user)
    return message.user == user || (user && user.role == 'admin')
  end
end

app/helpers/sessions_helper.rb
module SessionsHelper
  def log_in(user)
    session[:user_id] = user.id
  end

  def current_user
    if session[:user_id]
      @current_user ||= User.find_by(id: session[:user_id])
    end
  end

  def logged_in?
    !current_user.nil?
  end

  def log_out
    session.delete(:user_id)
    @current_user = nil
  end

  def current_user?(user)
    user == current_user
  end

  def redirect_back_or(default)
    redirect_to(session[:forwarding_url] || default)
    session.delete(:forwarding_url)
  end

  def store_location
    session[:forwarding_url] = request.original_url if request.get?
  end
end

app/helpers/users_helper.rb
module UsersHelper
end

app/views/layouts/_header.html.erb
<nav class="navbar mb-2">
  <div class="container-fluid">
    <div class="navbar-header">
      <%= link_to "Home", root_path, class: "mx-2" %>
      <%= link_to "Messages", messages_path, class: "mx-2" %>
    </div>
    <% if logged_in? %>
      <ul class="nav navbar-right ">
        <li><%= @current_user.name %></li>
        <li><%= link_to "Log out", logout_path, class: "mx-2", method: :delete %></li> 
      </ul>
    <% else %>
      <ul class="nav navbar-right ">
        <li><%= link_to "Log in", login_path, class: "mx-2" %></li> 
        <li><%= link_to "Sign up", signup_path, class: "mx-2" %></li>
      </ul>
    <% end %>
  </div>
</nav>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Web2lab2</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
    <%= javascript_include_tag "application", "data-turbo-track": "reload", defer: true %>
    <script src="https://kit.fontawesome.com/952dfd9181.js" crossorigin="anonymous"></script>
  </head>

  <body>
    <%= render 'layouts/header' %>
    <% flash.each do |message_type, message| %>
      <div class="alert alert-<%= message_type %>"><%= message %></div>
    <% end %>
    <%= yield %>
  </body>
</html>

app/views/messages/edit.html.erb
<h1 class='text-center'>Edit message</h1>

<div class="row">
  <div class="col-md-6 offset-3">
    <%= form_for @message do |f| %>
      <% if @message.errors.any? %>
        <div id="error_explanation">
          <div class="alert alert-danger">
            The form contains <%= pluralize(@message.errors.count, "error") %>.
          </div>
          <ul>
          <% @message.errors.full_messages.each do |msg| %>
            <li class='text-danger'><%= msg %></li>
          <% end %>
          </ul>
        </div>
      <% end %>
      
      <%= f.label :title %>
      <%= f.text_field :title, class: 'form-control' %>

      <%= f.label :body %>
      <%= f.text_area :body, size: "70x10", class: 'form-control' %>

      <%= f.submit "Edit", class: " mt-2 btn btn-primary" %>
    <% end %>
  </div>
</div>

app/views/messages/home.html.erb
<div class="text-center home">
  <h2>XSS pohranjeni & Loša kontrola pristupa</h2>
</div>

<div class="m-5">
  <h5>Admin korisnički računi</h5>
  <p>
    Postoje dva korisnička računa s admin ovlastima.<br/>
    Admin može brisati poruke od drugih korisnika.
  </p>
  <p>
    admin:password<br/>
    admin2:password
  </p>

  <h5>XSS pohranjeni</h5>
  <p>
    Postoje dvije zaštite protiv XSS napada.<br/>
    Senatizacija podataka prije njihovog spremanja u bazu.<br/>
    Isključivanje izvršavanja HTML koda iz podataka koji se prikazuju.
  </p>

  <h5>Dobra kontrola pristupa</h5>
  <p>
    Ako je isključena dobra kontrola pristupa bilo tko može, ako zna putanju, urediti/obrisati poruku.<br/>
    <a href="#">/messages/<i>id</i>/edit</a> - uređivanje poruke<br/>
    <a href="#">/messages/<i>id</i>/delete</a> - brisanje poruke
  </p>
</div>

<br/><br/>
<h4 class='text-center'>Postavke</h4>
<div class="row">
  <div class="col-md-6 offset-3">
    <%= form_with(url: root_path, scope: :settings, local: true) do |f| %>
      <%= f.check_box :xssStore, checked: check_if_true(@settings['xssStore']) %>
      <%= f.label "XSS zaštita tokom spremanja u bazu", for: :settings_xssStore %>
      <br/>

      <%= f.check_box :xssRender, checked: check_if_true(@settings['xssRender']) %>
      <%= f.label "XSS zaštita tokom renderanja stranice", for: :settings_xssRender %>
      <br/>

      <%= f.check_box :accessControl, checked: check_if_true(@settings['accessControl']) %>
      <%= f.label "Dobra kontrola pristupa", for: :settings_accessControl %>
      <br/>

      <div class="text-center"><%= f.submit "Save", class: "mt-3 btn btn-primary" %></div>
    <% end %>
  </div>
</div>

app/views/messages/index.html.erb
<div>
  <div class="row d-flex justify-content-center">
    <div class="col-md-12 col-lg-10">
      <div class="card text-dark">
        <% if @messages.empty? %>
          <div class="card-body p-4">
            <h4 class="mb-0">Messages</h4>
            <a href=<%= new_message_path %> style="text-decoration: none; text-color: black;"><p class="fw-light mb-4 pb-2">Create new <i class="fas fa-plus-circle"></i></p></a>
          </div>
        <% end %>
        
        <% @messages.each do |m| %>
        <div class="card-body p-4">

          <% if m == @messages.first %>
            <h4 class="mb-0">Messages</h4>
            <a href=<%= new_message_path %> style="text-decoration: none; text-color: black;"><p class="fw-light mb-4 pb-2">Create new <i class="fas fa-plus-circle"></i></p></a>
          <% end %>

          <div class="d-flex flex-start">
            <img class="rounded-circle shadow-1-strong me-3"
              src="https://external-content.duckduckgo.com/iu/?u=https%3A%2F%2Fcdn2.iconfinder.com%2Fdata%2Ficons%2Favatars-99%2F62%2Favatar-366-456318-512.png&f=1&nofb=1&ipt=17fe6afeee92f1939ed62f04fbbef235329395eb64ed7dd86ee5c31f15c32204&ipo=images" alt="avatar" width="60"
              height="60" />
            <div>
              <h6 class="fw-bold mb-1"><%= check_xss_render(m.user.name) %></h6>
              <div class="d-flex align-items-center mb-3">
                <p class="mb-0">
                  <a href=<%= message_path(m) %>><span class="badge bg-primary">ID: <%= m.id %></span></a>
                </p>
                <% if can_edit(m, current_user) %><a href=<%= edit_message_path(m) %>><i class="fas fa-pencil-alt ms-2"></i></a><% end %>
                <% if can_delete(m, current_user) %><a href=<%= "/messages/#{m.id}/delete" %>><i class="fas fa-eraser ms-2"></i></a><% end %>
              </div>
              <h4><%= check_xss_render(m.title) %></h4>
              <p class="mb-0"><%= check_xss_render(m.body) %></p>
            </div>
          </div>
        </div>

        <hr class="my-0" />
        <% end %>
      </div>
    </div>
  </div>
</div>

app/views/messages/new.html.erb
<h1 class='text-center'>New message</h1>

<div class="row">
  <div class="col-md-6 offset-3">
    <%= form_with(model: @message, local: true) do |f| %>
      <% if @message.errors.any? %>
        <div id="error_explanation">
          <div class="alert alert-danger">
            The form contains <%= pluralize(@message.errors.count, "error") %>.
          </div>
          <ul>
          <% @message.errors.full_messages.each do |msg| %>
            <li class='text-danger'><%= msg %></li>
          <% end %>
          </ul>
        </div>
      <% end %>
      
      <%= f.label :title %>
      <%= f.text_field :title, class: 'form-control' %>

      <%= f.label :body %>
      <%= f.text_area :body, size: "70x10", class: 'form-control' %>

      <%= f.submit "Create", class: " mt-2 btn btn-primary" %>
    <% end %>
  </div>
</div>

app/views/messages/show.html.erb
<div class="row">
  <div class="col-md-6 offset-3">
    <h3 class="text-center"><strong>ID: <%= @message.id %></strong></h3>
    <h1 class="text-center"><strong><%= check_xss_render(@message.title) %></strong></h1>
    <h4 style="text-align: justify;"><%= check_xss_render(@message.body) %></h4>

    <br /><br /><br />
    <% if can_edit(@message, current_user) %><%= link_to 'Edit', edit_message_path(@message) %><% end %>
    <% if can_delete(@message, current_user) %><%= link_to 'Delete', "/messages/#{@message.id}/delete" %><% end %>
  </div>
</div>

app/views/shared/_error_messages.html.erb
<% if @user.errors.any? %>
  <div id="error_explanation">
    <div class="alert alert-danger">
      The form contains <%= pluralize(@user.errors.count, "error") %>.
    </div>
    <ul>
    <% @user.errors.full_messages.each do |msg| %>
      <li class='text-danger'><%= msg %></li>
    <% end %>
    </ul>
  </div>
<% end %>

app/views/users/new.html.erb
<h1 class='text-center'>Sign up</h1>

<div class="row">
  <div class="col-md-4 offset-4">
    <%= form_with(model: @user, local: true) do |f| %>
      <%= render 'shared/error_messages' %>

      <%= f.label :username %>
      <%= f.text_field :name, class: 'mb-1 form-control' %>

      <%= f.label :password %>
      <%= f.password_field :password, class: 'mb-1 form-control' %>

      <%= f.label :password_confirmation, "Confirmation" %>
      <%= f.password_field :password_confirmation, class: 'mb-1 form-control' %>

      <%= f.submit "Create my account", class: "mt-2 btn btn-primary" %>
    <% end %>
  </div>
</div>

app/views/users/show.html.erb
<div class="row">
  <div class="offset-4 col-md-4">
      <h3 class='text-center'>
        Username: <%= @user.name %>
      </h3>
      <h3 class='text-center'>
        Role: <%= @user.role %>
      </h3>
  </div>
</div>